/* 
    Ec      Copyright (C)   2001 Marc Dechico


    ec_menu.c : Teletyp interface to let the user play
    
     
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    To contact the author:	Marc Dechico
			        Kerfring
			        29390 SCAER France
				tel: 06 80 83 74 99
				Mail: ec@dechico.com 
    
*/
//#include "ec_data.h"

//#include "ec_eva.h"
#include "ec_menu.h"

/*************************************************/
/* external functions                            */
/*************************************************/

extern void 	ini_pgm 	(void);
extern int      jou_int_jou	(char *ptc_dep,	         	/* joue interactif + reponse ordinateur  */
				 char *ptc_arr);
extern int      jou_int_ctl	(char *ptc_dep,	        	/* joue interactif + controle echec  */
				 char *ptc_arr);
extern int      sim_jou         (void);                         /* simul et joue  */
extern int      ann_cou_int     (void);	                        /* annule coup interactif */
extern int      cha_mes         (int i_mes_num,                 /* Chargement variable avec message */
				 char *tc_lib_mes);
/*ec_simu */
extern int      simul_eva       (int i_pro_sim_niv_wrk,         /* simulation pour evaluation meilleur mvt */
				 int i_pro_sim_inc_wrk	);
extern void     sto_sim 	 (void);	        	/* Stop simulation  */

extern  int     pro_pio_ver_lib_pie    (char c_lib_pie);        /* verifie validite du libelle piece promotion du pion */
extern  int     pro_pio_ver_typ_pie    (char c_typ_pie);        /* verifie validite du type piece promotion du pion */
extern char     pro_pio_tra_tpie_lpie  (char  i_typ_pie);       /* traduit type piece en libelle piece*/
extern  char    pro_pio_tra_tmvt_lpie  (int i_typ_mvt);         /* traduit type mvt en type  piece*/
extern  char    pro_pio_tra_lpie_tpie  (char c_lib_pie);        /* traduit libelle piece en type piece */
extern  int     cho_niv                (int i_niv, int i_inc);  /* Choix profondeur et incrément de simulation */
extern  int     sav_dsk                (char tc_nom_fic[40]);   /* Sauvegarde et restauration partie sur disque */
extern  int     rst_dsk                (char tc_nom_fic[40]);

/*ec_eva*/
extern float 	eva_cou_cam 	(int nn);		/* analyse de la couverture */
extern void  	sim_aut 	(void);			/* pour faire jouer automatiquement */
extern  void  	test_aut 	(void);			/* pour techercher d'éventuel bugs  */

extern  void aff_nex_pag(void);                         /* print next/previous  page   */
extern  void aff_pre_pag(void);                         /* common to all statistic printing */

/* these are only  for debuging purpose */
extern void aff_pie (int i_cam);
extern void aff_pie_lin(int i_pie,struct st_pie *ptst_pie); 
extern  void aff_hst (int i_pro_deb, int i_pro_fin);

/* print score for the mouvement several pondered factor  */
extern  int aff_not_1 (int *pi_mei_mvt);
extern  int aff_not_2 (int *pi_mei_mvt);

/* print score for one initial moment datas for each depth  */
extern int aff_mvt_ini(int i_mvt_ini);

/*************************************************/
/* local    functions                            */
/*************************************************/
static void mnu_cde (void);
static void mnu_cde_prt(char tc_com[80],int *pi_mei_mvt);
static void mnu_cde_mov(char tc_com[80]);
static void mnu_cde_rec(char tc_com[80],int *pi_mei_mvt);
static void mnu_cde_fil(char tc_com[80],int i_cot_aff);
static void mnu_hlp (void);

/* affichage pied de page */
static void prt_foo (int i_pro_act,int i_pro_sim_niv,int i_pro_sim_inc);

/* affichage de l'échiquier */
static void aff_ech (int i_cam);
void        aff_ech_wra (int i_cam);

/* gestion interruption simulation */
static void sto_sim_msg(void);
void        sto_sim_msg_wra (void);

/* Affichage calcul en cours */
extern  void aff_cal_en_cou(int i_not_cpt_mvt_ini);

/* Affichage message  utilisateur  */
void aff_mes_uti(int i_mes_num); 

/* choix promotion du  pion  */
static char pro_pio_cho (void);		 
char pro_pio_cho_wra (void);
/* choix version d'évaluation */
static void cho_ver(void);
static  void sup_blanc    (char *tc_str);
static  void sai_com       (char tc_com [80]);

/* Change la prfondeur de simulation */
static int chg_lvl(char *tc_com);

/*****************************************************************************/
/*  Main                                                                     */
/*****************************************************************************/
int
main (argc, argv)
     int argc;
     char *argv[];
{
  int optc;
  int h = 0, v = 0, lose = 0;

  progname = argv[0];

#ifdef HAVE_SETLOCALE
  /* Set locale via LC_ALL.  */
  setlocale (LC_ALL, "");
#endif

#if ENABLE_NLS
  /* Set the text message domain.  */
  bindtextdomain (package, LOCALEDIR);
  textdomain (package);
#endif
  while ((optc = getopt_long (argc, argv, "hmntv", longopts, (int *) 0))
         != EOF)
    switch (optc)
      {
      case 'v':
        v = 1;
        break;
      case 'h':
        h = 1;
        break;
      default:
        lose = 1;
        break;
      }
  
if  (lose || optind < argc)
    {
      /* Print error message and exit.  */
      if (optind < argc)
        fputs (_("Too many arguments\n"), stderr);
      fprintf (stderr, _("Try `%s --help' for more information.\n"), 
               progname);
      exit (1);
    }

 /* `help' should come first.  If `help' is requested, ignore the other
     options. */
  if (h)
    {
      /* Print help info and exit.  */
      /* TRANSLATORS: --help output 1
         no-wrap */
      fputs (_("\
EC Chess Programm.\n"), stdout);
      printf ("\n");
      /* TRANSLATORS: --help output 2
         no-wrap */
      printf (_("\
Usage: %s [OPTION]\n"), progname);

      printf ("\n");
      /* TRANSLATORS: --help output 3 : options 1/2
         no-wrap */
      fputs (_("\
  -h, --help          display this help and exit\n\
  -v, --version       display version information and exit\n"), stdout);

 /* Suppressed: problem with help2man 
      printf ("\n");
      fputs (_("\
Commands to play interactively:\n"), stdout);

      mnu_hlp();
      printf ("\n");
 */      
      printf ("\n");
   
   /* TRANSLATORS: --help output 5 (end)
         TRANSLATORS, please don't forget to add the contact address for
         your translation!
         no-wrap */
      printf (_("\
Report bugs to <%s>.\n"), package_bugreport);

      exit (0);
    }

  if (v)
    {
      /* Print version number.  */
      printf ("%s %s\n", package, version);
      /* xgettext: no-wrap */
      printf ("\n");
      printf (_("\
Copyright (C) %s  Marc Dechico.\n\
There is NO warranty; not even for MERCHANTABILITY or FITNESS FOR A\n\
PARTICULAR PURPOSE.  You may redistribute copies of GNU %s under the terms\n\
of the GNU General Public License.\n\
For more information about these matters, see the file named COPYING.\n"),
              "2001", package);
      exit (0);
    }

    mnu_cde();

    return 0;
}
/*********************************************************************/
/* test function */
/********************************************************************/


static void test12 (void)
{
#define NBR 1000


  int i;
  struct st_ind *pst_cur_ind=NULL;
  int *p_new_mem;
  extern int mem_lst_ini  (struct st_ind  **ppst_cur_ind);
  extern int mem_lst_add  (struct st_ind  **ppst_cur_ind, void * p_new_mem);
  extern int mem_lst_fre  (struct st_ind  **ppst_cur_ind);
  extern int mem_lst_lst  (struct st_ind  *pst_cur_ind);

  mem_lst_ini (&pst_cur_ind);
  for (i=0;i<NBR;i++)
    {
      p_new_mem=malloc(sizeof(int));

      if(p_new_mem!=NULL)
	{
	  *p_new_mem=i;
	  mem_lst_add (&pst_cur_ind,p_new_mem);
	}

    }
    /*   printf("\ni=%d adr=%d",*pv[i],pv[i]);*/
  printf("\n Memory registered %d",i);
  /*  mem_lst_lst(pst_cur_ind);*/

  /* mem_lst_fre(&pst_cur_ind);*/
  printf("\n Memory freed");

  i=abs(i); 
}
/*****************************************************************************/
/*  Affichage                                                                */
/*****************************************************************************/

/*  Menu de commande                                                         */

static void mnu_cde (void)
{
  char tc_com[80];
	
  int i_mei_mvt=0;	/* N° du meilleur mvt */
  int i_msg=0;              /* message retour de fonction */



  /* initialisation programme */
  ini_pgm();

  /* cote d'affichage */
  i_cot_aff               =  BLANC;

  /*pour sauvegarde et acces autre fct sauf simu qui attend param */
  i_pro_sim_niv	= 3;			/* niveau par default */
  i_pro_sim_inc	= 2;			/* niveau par default */

  printf("%s",tc_sep_tir);
	
  aff_ech(i_cot_aff);

  while (1)
    {
      char c;
      fflush(stdin);
      e_aff_cal_cou = Y;

      prt_foo(i_pro_act,i_pro_sim_niv,i_pro_sim_inc);

      sai_com(tc_com);
		
      c=tolower(tc_com[0]);
	
      if (c== '+')
	{
	  aff_nex_pag();
	  continue;
	}
      
      if (c == '-')
	{
	  aff_pre_pag();
	  continue;
	}
               
      if (c ==  (char) *(_("CDE_p")+4) )
	{                  
	  mnu_cde_prt(tc_com, &i_mei_mvt);
	  continue;
	} 	

      if (c == (char) *(_("CDE_m")+4) )
	{                  	
	  mnu_cde_mov(tc_com);
	  continue;
	}

      if (c == (char) *(_("CDE_b")+4) )
	{                  	
	  e_cur_aff=e_pas_aff;
	  i_msg=ann_cou_int();
	  if(i_msg<0)	
	    aff_mes_uti(i_msg);
	  else
	    aff_ech(i_cot_aff);
	  continue;
	}

      if (c == (char) *(_("CDE_r")+4) )
	{                  
	  mnu_cde_rec(tc_com, &i_mei_mvt);
	  continue;
	}

      if (c == (char) *(_("CDE_s")+4) )
	{                   
	  if(i_cot_aff==0)
	    i_cot_aff=1;
	  else
	    i_cot_aff=0;
	  aff_ech(i_cot_aff);
	  continue ;
	}

      if (c == (char) *(_("CDE_l")+4) ) 
	{                  
	  i_msg=chg_lvl(tc_com);
	  if (i_msg<0)
	    aff_mes_uti(i_msg); /* oraganisation */
	  continue ;
	}
			
      if (c == (char) *(_("CDE_f")+4) ) 
	{					
	  mnu_cde_fil(tc_com, i_cot_aff);
	  continue;
	}

      if (c == (char) *(_("CDE_n")+4) )
	{                  
	  e_cur_aff=e_pas_aff;
	  ini_pgm();
	  aff_ech(i_cot_aff);
	  continue;
	}
		  
      if (c == (char) *(_("CDE_?")+4) )
	{                   	
	  mnu_hlp();
	  continue;
	}

      if (c == (char) *(_("CDE_q")+4) )               
	return ;

      if (c == 't')
	{                  
	  e_cur_aff=e_pas_aff;
	  test12() ;
	  continue;
	}

      if (c == 'u') 
	{                   
	  e_cur_aff=e_pas_aff;
	  /*	  rec_bug() ;*/
	  continue;
	}

      if (c == 'x')
	{                  
	  cho_ver() ;
	  continue;
	}

      /* Commande inconnue tapez h pour aide*/
      if(c !='\0')
	{
	  printf(tc_sep_ast );
	  printf("\n");
	  printf( _("Unknown command type ? for help") );
	  printf(tc_sep_ast );
	  printf("\a");
	}	   
    }	 
}

static void 
mnu_cde_prt(char tc_com[80],int *pi_mei_mvt)
{
  int i_mvt = 0;
  int i_msg = 0;
  char c;
 
  c= tolower (tc_com[1]); 
    
  if ( c ==  (char) *(_("CDE_PRT_h")+8) )
    {                  
      e_cur_aff=e_pas_aff;
      aff_hst(i_pro_act,i_pro_sim_max_inf);
      return ;
    }

  if( c ==  '0')
    {                       
      e_cur_aff=e_pas_aff;
      aff_hst(0,i_pro_act);
      return ;
    }

  if( c ==  (char) *(_("CDE_PRT_p")+8) ) 
    {                  
      e_cur_aff=e_pas_aff;
      if (tc_com[2]== '0')
	aff_pie(BLANC);
      else
	aff_pie(NOIR);
      return ;
    }

  if( c ==  (char) *(_("CDE_PRT_b")+8) )
    {                  
      e_cur_aff=e_pas_aff;
      aff_ech(i_cot_aff);
      return ;
    }

  if( c ==   (char) *(_("CDE_PRT_m")+8) )
    {                  
      char cc;
      cc = tc_com[2];
  
	
      if( cc ==  '1')
	{  
	  e_cur_aff=e_aff_not_1;			
	  i_msg=  aff_not_1(pi_mei_mvt);
	  if(i_msg<0)
	    /* Calcul necessaire: taper r*/ 
	    aff_mes_uti(i_msg);				
	  return ;
	}
      if( cc ==  '2')
	{
	  e_cur_aff=e_aff_not_2;			
	  i_msg=  aff_not_2(pi_mei_mvt);
	  if(i_msg<0)
	    /* Calcul necessaire: taper r*/ 
	    aff_mes_uti(i_msg);			    
	  return ;
	}
      else
	{
	  e_cur_aff=e_aff_not_1;			
	  i_msg=  aff_not_1(pi_mei_mvt);
	  if(i_msg<0)
	    /* Calcul necessaire: taper r*/ 
	    aff_mes_uti(i_msg);			
	  return ; 
	}
      return ;
    }

  if( c ==  (char) *(_("CDE_PRT_i")+8) )
    {                  
      e_cur_aff=e_pas_aff;
      if (isdigit(tc_com[2]))
	i_mvt=atoi(&tc_com[2]);
      i_msg = aff_mvt_ini(i_mvt);
      if (i_msg<0) 
	aff_mes_uti(i_msg);			
      return ;
    }
  else
    {    
      mnu_hlp();
      return ;
    }
}	
static void 
mnu_cde_mov(char tc_com[80])
{
  /* argument p:play et m:move */
  char tc_dep[3];               		/* case de depart ex:A1 */
  char tc_arr[4];               		/* case d'arrivée ex:B2 ou A8C pour pion en cavalier */

  int i_msg=0;
  char c;

  e_cur_aff=e_pas_aff;
		
  c = tolower (tc_com[1]);
    
    if ( c == (char) *(_("CDE_MOV_m")+8) )
      {              
	/* reponsonce auto de l'ordi */
	if(isdigit(tc_com[2]))
	{
	  /*  une coordonnée  pourrait être confondue avec l'instrution deplace*/
	  strncpy(tc_dep,&tc_com[1],2);
	  strncpy(tc_arr,&tc_com[3],3);
	  i_msg=jou_int_ctl(tc_dep,tc_arr);
	
	}
	else
	{
	  strncpy(tc_dep,&tc_com[2],2);
	  strncpy(tc_arr,&tc_com[4],3);
	  i_msg=jou_int_jou(tc_dep,tc_arr);
	}
      }                	
    else
      {
	/* mouvement sans reponse de l'ordi */	  
	strncpy(tc_dep,&tc_com[1],2);
	strncpy(tc_arr,&tc_com[3],3);             
	i_msg=jou_int_ctl(tc_dep,tc_arr);
      }	
    if (i_msg<0) 
      aff_mes_uti(i_msg);
    aff_ech(i_cot_aff);	
}

static void 
mnu_cde_rec(char tc_com[80],int *pi_mei_mvt)
{
  int i_msg=0;
  char c;

  e_cur_aff=e_pas_aff;
  c = tolower (tc_com[1]);
  /* reckon and move */
  if (c == (char) *(_("CDE_REC_m")+8))                   
    {
      i_msg=sim_jou();
      if(i_msg<0)
	{
	  aff_mes_uti(i_msg);
	}	
							
      aff_ech(i_cot_aff);
    }
  else 
    /* reckon and print */
                    
    {
      *pi_mei_mvt=simul_eva(i_pro_sim_niv,
			    i_pro_sim_inc);
      if (*pi_mei_mvt>=0)
	{
	  e_cur_aff=e_aff_not_1;
	  tst_aff[e_aff_not_1].i_cur_pag=0;
	  i_msg=aff_not_1(pi_mei_mvt);
	  if (i_msg<0) aff_mes_uti(i_msg);
	}
      else
	aff_mes_uti(*pi_mei_mvt);	
    }
}

static void 
mnu_cde_fil(char tc_com[80],int i_cot_aff)
{
  int i_msg;
  char c;
  c=tolower (tc_com[1]);
    
  if ( c == (char) *(_("CDE_FIL_s")+8) )			/* sauvegarde */
    {
      i_msg=sav_dsk("ec.std");
      if(i_msg<0) aff_mes_uti(i_msg);
      return;
    }

  if ( c == (char) *(_("CDE_FIL_l")+8))			/* load */
    {     e_cur_aff=e_pas_aff;
    i_msg=rst_dsk("ec.std");
    if (i_msg<0)
      aff_mes_uti(i_msg);
    else
      aff_ech(i_cot_aff);
    return;
    }
  if (c ==  'w')			/* load  fichier de travail*/
    {
      e_cur_aff=e_pas_aff;
      i_msg=rst_dsk("ec.wrk");
      if(i_msg<0)
	aff_mes_uti(i_msg);
      else
	aff_ech(i_cot_aff);
      return;
    }
}

static void
prt_foo (int i_pro_act,int i_pro_sim_niv,int i_pro_sim_inc)
{
  printf("%s",tc_sep_tir);
  if(i_pro_act>0)
    {
      printf("\n");
      /* Mouvement precedent */
      printf( _("Prv_Mvt:") );
      printf("%s",tc_lib_cas[ts_hst_pro[i_pro_act].i_pos_ori_n]);
      printf("%s",tc_lib_cas[ts_hst_pro[i_pro_act].i_pos_n]);
      printf("%c",pro_pio_tra_tmvt_lpie (ts_hst_pro[i_pro_act].i_typ_mvt));
    }
  else
    {
      printf("\n");
    }
   if(ts_hst_pro[i_pro_act+1].i_cam== BLANC)
    /* Tour au blanc */ 
    printf( _("Turn=White") );
  else
    {
      /* tour au noir */
      printf( _("Turn=Black") );
    }
  printf(" ");
  /* Niveau Increment Cote(machine humain)*/
  printf( _("Curr_Deep=%i Simu=%i.%i") ,
	  i_pro_act,
	  i_pro_sim_niv,
	  i_pro_sim_inc
	  );
  /* Version eva */
  printf (" V:%02u",i_ver_eva);

  /* Aide:tapez h */  
  printf(" ");
  printf( _("Help:Type ?") );
  printf("\n>");

}

static void
cho_ver (void)
{
  int ver;
  scanf("%i",&ver);
  if (tpf_eva[ver] != NULL)
    {
      i_ver_eva = ver;
      pf_eva = tpf_eva[ver];
    }
  else
    printf ("\nErreur Num Evaluation");

}

static int 
chg_lvl(char *tc_com)
{
  int cpt,cpt2;
  char tc_pro_sim[5];
  char tc_pro_sim_inc[5];
  int pro_sim,pro_sim_inc;
  cpt2=0;
  for(cpt=1;cpt < 80 ;cpt++)
    {
      if (tc_com[cpt]=='.')
	{
	  tc_pro_sim[cpt2]='\0';
	  break;
	}
      else
	{
	  tc_pro_sim[cpt2++]=tc_com[cpt];
	}
    }
  pro_sim=atoi(tc_pro_sim);
  /* bug : segmentation fault if 'lw + enter */
  cpt2=0;
  for(cpt=cpt+1;cpt < 80 ;cpt++)
    {
      if (isdigit(tc_com[cpt]))
	{
	  tc_pro_sim_inc[cpt2++]=tc_com[cpt];
	
	}
      else
	{
	  tc_pro_sim_inc[cpt2]='\0';
	  break;
	}
    }
  pro_sim_inc=atoi(tc_pro_sim_inc);

  return (cho_niv(pro_sim,pro_sim_inc));


}
/* affichage aide du menu cde  */
static void 
mnu_hlp (void)
{
  printf( _("\nmove                   : m  A7A8N (N only when pawn promoted to Knight)") );
  printf( _("\nmove and move          : mm A7A8C (the computer replys automatically)") );
  printf( _("\nreckon and move        : rm ") );
  printf( _("\nback                   : b  ") );
  printf( _("\nside                   : s (change side black/white)") );
  printf( _("\nlevel (deepness)       : l 4.2") );
  printf( _("\nfile save              : fs (save game)") );
  printf( _("\nfile load              : fl (load game) ") );
  printf( _("\nnew game               : n") );
  printf( _("\nquit                   : q") );
  printf( _("\nreckon and print marks : r") );
  printf( _("\nprint board            : pb") );
  printf( _("\nprint marKs            : pm ") );
  printf( _("\nprint marKs 2          : pm2 ") );
  printf( _("\nprint initial move     : pi 0 (for the first initial move)") );
  printf( _("\nhelp                   : ? ") );

}
/*  Affichage de l'echiquier */
void 
aff_ech_wra (int i_cam)
{
  aff_ech(i_cam);
}

/*  Affichage de l'echiquier */
static void 
aff_ech (int i_cam)
{
  int x,y;
  int i_pos_n=0;
  int i_lib_lic;
  char b =' ';       /* Case noire	*/
  char n =' ' ;	      /* Case blanche	*/

  int b_n; /* blanc ou noir: 1 ou -1 */
  char c_lib_pie;

  struct { char *label;}
  tc_lib_lic []=
    {
      {package_string},
      /* TRANSLATORS: limit to 40 char to fit a standard screen */
      {N_("Copyright (C) 2001 Marc Dechico")},
 
      {" "},

      {package_bugreport},     

      {package_www},

      {" "},

     /* TRANSLATORS: limit to 40 char to fit a standard screen */
       {N_("There is ABSOLUTELY NO WARRANTY.")},

     /* TRANSLATORS: limit to 40 char to fit a standard screen */
       {N_("This is free software, and you are ")},

     /* TRANSLATORS: limit to 40 char to fit a standard screen */
       {N_("welcome to redistribute it under the")},

     /* TRANSLATORS: limit to 40 char to fit a standard screen */
       {N_("GNU-Licences terms.See the file COPYING.")},

     /* TRANSLATORS: limit to 40 char to fit a standard screen */
       {N_("You can contribute to the efforts made") },

     /* TRANSLATORS: limit to 40 char to fit a standard screen */
       {N_("by the author by sendind encouragment or")},

     /* TRANSLATORS: limit to 40 char to fit a standard screen */
       {N_("a crossed check (10 Euros) to :")},

     /* TRANSLATORS: limit to 40 char to fit a standard screen */
       { " " },

     /* TRANSLATORS: limit to 40 char to fit a standard screen */
       {N_("Marc DECHICO")},

     /* TRANSLATORS: limit to 40 char to fit a standard screen */
       {N_("Kerfring")},

     /* TRANSLATORS: limit to 40 char to fit a standard screen */
       {N_("29390 SCAER FRANCE")}

    };


  /* pour les noir  (i_cam = 1) les noir sont en bas */
  if (i_cam==NOIR)
    printf("\n | H | G | F | E | D | C | B | A | ");
  else
    printf("\n | A | B | C | D | E | F | G | H | ");

  printf("    %s",_(tc_lib_lic[0].label));
  printf("\n-+===============================+-");
  printf("    %s",_(tc_lib_lic[1].label));
  i_lib_lic = 2;

  if (i_cam == NOIR)
    {
 
      b_n = 1;

	
      for (y=1;y<=8;y++)

	{	
	
	  b_n *=-1;

	  printf("\n%i",y);
	  for (x=8;x>=1;x--)
	    {
	      i_pos_n = (y*10)+x;
	      if (x<8)
		printf("|");
	      else
		printf(":"); 
	      b_n *=-1;
	
	      if(ts_ech[i_pos_n].i_cam<0)
		{
				  
		  if (b_n > 0) printf(" %c ",b);
		  else 		  printf(" %c ",n);
	
		}
	      else
		{
		  c_lib_pie=
		    (tpts_pie[(ts_ech[i_pos_n].i_cam)]
		     +
		     (ts_ech[i_pos_n].i_Id))->c_lib_pie;
		  if (ts_ech[i_pos_n].i_cam== BLANC)
		    printf("(%c)",c_lib_pie);
		  else
		    printf(" %c ",c_lib_pie);

		}

	    }
	  printf(":%i",y);                                
	  if ((i_lib_lic<17 && i_pro_act==0)|| i_lib_lic <5) 	    
	    printf("    %s",_(tc_lib_lic[i_lib_lic++].label));
	  if (y<8)
	    printf("\n-+ - + - + - + - + - + - + - + - +-"); 
	  if ((i_lib_lic<17 && i_pro_act==0)|| i_lib_lic<5) 
	    printf("    %s",_(tc_lib_lic[i_lib_lic++].label));

	}
  
    }
  else
    /* pour les blanc (i_cam = BLANC) les blanc sont en bas */
    {


      b_n = 1;
 
      for (y=8;y>=1;y--)
	{
	  b_n *=-1;
	  printf("\n%i",y);
	  for (x=1;x<=8;x++)
	    {
	      i_pos_n= (y*10) + x;
	      if (x>1)
		printf("|");
	      else
		printf(":"); 
	      b_n *=-1;
	
	      if(ts_ech[i_pos_n].i_cam<0)
		{
		  if (b_n > 0) printf(" %c ",b);
		  else 		  printf(" %c ",n);

		}
	      else
		{
		  c_lib_pie=
		    (tpts_pie[(ts_ech[i_pos_n].i_cam)]
		     +
		     (ts_ech[i_pos_n].i_Id))->c_lib_pie;
		  if (ts_ech[i_pos_n].i_cam== BLANC)
		    printf("(%c)",c_lib_pie);
		  else
		    printf(" %c ",c_lib_pie);

		}

	    }
	  printf(":%i",y);
	  if ((i_lib_lic<17 && i_pro_act==0)|| i_lib_lic<5)
	    printf("    %s",_(tc_lib_lic[i_lib_lic++].label));
	  if (y>1)
	    printf("\n-+ - + - + - + - + - + - + - + - +-");
	  if ((i_lib_lic<17 && i_pro_act==0)|| i_lib_lic<5) 
	    printf("    %s",_(tc_lib_lic[i_lib_lic++].label));

	}
    }
  printf("\n-+===============================+-");
  if (i_cam==NOIR)
    printf("\n | H | G | F | E | D | C | B | A | ");
  else
    printf("\n | A | B | C | D | E | F | G | H | ");


}



void 
sto_sim_msg_wra (void)
{	
  sto_sim_msg();
}
void sto_sim_msg(void)
{
  fflush(stdin);
  /* \nVoulez vous interrompre le calcul? (O/N) */
  printf(tc_sep_ast);
  printf("\n");
  printf( _("Dou you want to stop the computation ? (y/n)") );
  printf(tc_sep_ast);
  printf("\n");
  /* getchar();*/
  if( tolower(getchar()) == (char) *(_("y")) )
    sto_sim();
  else
    e_sto_sim_cla = N;
}

/* Choix remplacement du pion */
/* Verifie si piece de promotion est ok sinon demande interactive */
/* et traduction lib piece vers type piece */

char 
pro_pio_cho_wra (void)
{
  return pro_pio_cho();
}
char pro_pio_cho (void)
{
  int i_msg=0;
  int c;

  /* c=getchar();  bricolage! */
  /* Quelle piece voulez vous pour remplacer le pion? */
  printf(tc_sep_ast);
  printf("\n");
  printf( _("Which piece for the pawn's promotion ? ") );
  printf(tc_sep_ast);
  printf("\n");
      
  while (1)
    {
      fflush(stdin);

      c=getchar();
	  
      i_msg=pro_pio_ver_lib_pie(c);

      if(i_msg>=0)
	return (pro_pio_tra_lpie_tpie(c));
      else
	aff_mes_uti(i_msg);
      printf("\n");
	   
    }
 
}

/* Affichage message utilisateur  */
void aff_mes_uti(int i_mes_num)
{
  /*recupere le texte du message */
  char tc_lib_mes[LEN_MES];
  cha_mes (i_mes_num, tc_lib_mes);
 

  printf("%s",tc_sep_ast);
  printf("\n%s",tc_lib_mes);

  printf("%s",tc_sep_ast);
  printf("\a"); /* alarme */
}
static void sup_blanc(char *tc_str)
{
  /* supprime les blanc de la zone de saisie */
  int i=0;
  int ii=0;
  for(i=0;i<=(int)strlen(tc_str);i++)
    {   
      if(tc_str[i]!=' ')
	{
	  tc_str[ii++]=tc_str[i];
	}
    }
  tc_str[ii]='\0';
}
static void sai_com (char tc_com [80])
{
  int i=0;
  int c;
  
  while(1) 
    {  
      c=getchar();
      
      if (c !=10 && i<78 )
	tc_com[i++]=c;
      else 
	break;
    }	
  tc_com[i]='\0';
  sup_blanc(tc_com);
  return;
}

#ifdef C_ALLOCA /* xmalloc() is only used by alloca.c.  */

char *
xmalloc (size)
     unsigned int size;
{
  char *ptr = malloc (size);
  if (! ptr)
    {
      fprintf (stderr, _("%s: Virtual memory exhausted\n"), progname);
      exit (1);
    }
  return ptr;
}
#endif /* C_ALLOCA */

